#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "prot_cmc.h"
#include "prot_pcm2.h"

int main(int argc, char** argv) {

	cmc_prot_device* m_cmc_prot = new  cmc_prot_device;
	pcm2_prot_device* m_pcm2_prot = new pcm2_prot_device;
	uint8_t* rom;
	uint32_t rom_size;
	uint8_t* rom_fixed;
	uint32_t fixed_size;
	FILE* fpi, * fpo;
	int encflag = 0;	//0:decode 1:encode
	int titleflag = 0;	//0:mslug3 1:kof99 2:garou 3:kof2000 4:kof2002 5:samsh5sp 6:mslug4 7:mslug5
	int extra_xor = 0;
	int functionflag = 0;	//-1:cmcXX_gfx -2:sfix  >=0:vrom(swap value)

	fpi = fopen(argv[1], "rb");
	rom_size = atoi(argv[2]);
	fpo = fopen(argv[3], "wb");
	encflag = atoi(argv[4]);
	titleflag = atoi(argv[5]);
	functionflag = atoi(argv[6]);
	//fixed_size = atoi(argv[7]);	//fixed_sizeɔCӂ̒l΁ACROMfixed_sizë̗悾sfix_encode/decodełB
	fixed_size = rom_size;

	rom = (uint8_t*)malloc(sizeof(uint8_t) * rom_size);
	rom_fixed = (uint8_t*)malloc(sizeof(uint8_t) * fixed_size);

	fread(rom, sizeof(uint8_t), rom_size, fpi);

	if (functionflag == -1) {

		switch (titleflag) {
		case 0:
			extra_xor = MSLUG3_GFX_KEY;
			break;

		case 1:
			extra_xor = KOF99_GFX_KEY;
			break;

		case 2:
			extra_xor = GAROU_GFX_KEY;
			break;

		case 3:
			extra_xor = KOF2000_GFX_KEY;
			break;

		case 4:
			extra_xor = KOF2002_GFX_KEY;
			break;

		case 5:
			extra_xor = SAMSHO5SP_GFX_KEY;
			break;

		case 6:
			extra_xor = MSLUG4_GFX_KEY;
			break;

		case 7:
			extra_xor = MSLUG5_GFX_KEY;
			break;

		default:
			break;
		}

		if (titleflag <= 2) {
			if (encflag == 1) {
				m_cmc_prot->cmc42_gfx_encrypt(rom, rom_size, extra_xor);
			}
			else if (encflag == 0) {
				m_cmc_prot->cmc42_gfx_decrypt(rom, rom_size, extra_xor);
			}
		}
		else {
			if (encflag == 1) {
				m_cmc_prot->cmc50_gfx_encrypt(rom, rom_size, extra_xor);
			}
			else if (encflag == 0) {
				m_cmc_prot->cmc50_gfx_decrypt(rom, rom_size, extra_xor);
			}
		}
	}
	else if (functionflag==-2) {
		if (encflag == 1) {
			memcpy(rom_fixed, rom + rom_size - fixed_size, fixed_size);
			m_cmc_prot->sfix_encrypt(rom, rom_size, rom_fixed, fixed_size);
		}
		else if (encflag == 0) {
			m_cmc_prot->sfix_decrypt(rom, rom_size, rom_fixed, fixed_size);
			memcpy(rom + rom_size - fixed_size, rom_fixed, fixed_size);
		}
	}
	else{
		if (titleflag != 6) {
			if (encflag == 1) {
				m_pcm2_prot->unswap(rom, rom_size, functionflag);
			}
			else if (encflag == 0) {
				m_pcm2_prot->swap(rom, rom_size, functionflag);
			}
		}
		else {
			if (encflag == 1) {
				m_pcm2_prot->encrypt(rom, rom_size, functionflag);
			}
			else if (encflag == 0) {
				m_pcm2_prot->decrypt(rom, rom_size, functionflag);
			}
		}
	}

	fwrite(rom, sizeof(uint8_t), rom_size, fpo);

	free(rom);
	free(rom_fixed);

	delete m_cmc_prot;
	delete m_pcm2_prot;
	return 0;
}

//ȉAfNvǧĂяoiQlj

//from sma.cpp--------------------------------------------------------------------------------

///*************************************************
// mslug3
// **************************************************/
//
//void neogeo_sma_mslug3_cart_device::decrypt_all(DECRYPT_ALL_PARAMS)
//{
//	m_sma_prot->mslug3_decrypt_68k(cpuregion);
//	m_cmc_prot->cmc42_gfx_decrypt(spr_region, spr_region_size, MSLUG3_GFX_KEY);
//	m_cmc_prot->sfix_decrypt(spr_region, spr_region_size, fix_region, fix_region_size);
//}
//
///*************************************************
// kof99
//**************************************************/
//
//void neogeo_sma_kof99_cart_device::decrypt_all(DECRYPT_ALL_PARAMS)
//{
//	m_sma_prot->kof99_decrypt_68k(cpuregion);
//	m_cmc_prot->cmc42_gfx_decrypt(spr_region, spr_region_size, KOF99_GFX_KEY);
//	m_cmc_prot->sfix_decrypt(spr_region, spr_region_size, fix_region, fix_region_size);
//}
//
///*************************************************
// garou
//**************************************************/
//
//void neogeo_sma_garou_cart_device::decrypt_all(DECRYPT_ALL_PARAMS)
//{
//	m_sma_prot->garou_decrypt_68k(cpuregion);
//	m_cmc_prot->cmc42_gfx_decrypt(spr_region, spr_region_size, GAROU_GFX_KEY);
//	m_cmc_prot->sfix_decrypt(spr_region, spr_region_size, fix_region, fix_region_size);
//}
//
///*************************************************
// kof2000
//**************************************************/
//
//void neogeo_sma_kof2000_cart_device::decrypt_all(DECRYPT_ALL_PARAMS)
//{
//	m_sma_prot->kof2000_decrypt_68k(cpuregion);
//	m_cmc_prot->cmc50_m1_decrypt(audiocrypt_region, audiocrypt_region_size, audiocpu_region, audio_region_size);
//	m_cmc_prot->cmc50_gfx_decrypt(spr_region, spr_region_size, KOF2000_GFX_KEY);
//	m_cmc_prot->sfix_decrypt(spr_region, spr_region_size, fix_region, fix_region_size);
//}


//from kof2k2.cpp--------------------------------------------------------------------------------

///*************************************************
// kof2002
//**************************************************/
//
//void neogeo_kof2002_cart_device::decrypt_all(DECRYPT_ALL_PARAMS)
//{
//	m_kof2k2_prot->kof2002_decrypt_68k(cpuregion, cpuregion_size);
//	m_cmc_prot->cmc50_m1_decrypt(audiocrypt_region, audiocrypt_region_size, audiocpu_region, audio_region_size);
//	m_cmc_prot->cmc50_gfx_decrypt(spr_region, spr_region_size, KOF2002_GFX_KEY);
//	m_cmc_prot->sfix_decrypt(spr_region, spr_region_size, fix_region, fix_region_size);
//	m_pcm2_prot->swap(ym_region, ym_region_size, 0);
//}
//
///*************************************************
// samsh5sp
//**************************************************/
//
//void neogeo_samsho5sp_cart_device::decrypt_all(DECRYPT_ALL_PARAMS)
//{
//	m_kof2k2_prot->samsh5sp_decrypt_68k(cpuregion, cpuregion_size);
//	m_cmc_prot->cmc50_m1_decrypt(audiocrypt_region, audiocrypt_region_size, audiocpu_region, audio_region_size);
//	m_cmc_prot->cmc50_gfx_decrypt(spr_region, spr_region_size, SAMSHO5SP_GFX_KEY);
//	m_cmc_prot->sfix_decrypt(spr_region, spr_region_size, fix_region, fix_region_size);
//	m_pcm2_prot->swap(ym_region, ym_region_size, 6);
//}

//from pcm2.cpp--------------------------------------------------------------------------------

///*************************************************
// mslug4
//**************************************************/
//
//void neogeo_pcm2_mslug4_cart_device::decrypt_all(DECRYPT_ALL_PARAMS)
//{
//	m_cmc_prot->cmc50_m1_decrypt(audiocrypt_region, audiocrypt_region_size, audiocpu_region, audio_region_size);
//	m_cmc_prot->cmc50_gfx_decrypt(spr_region, spr_region_size, MSLUG4_GFX_KEY);
//	m_cmc_prot->sfix_decrypt(spr_region, spr_region_size, fix_region, fix_region_size);
//	m_pcm2_prot->decrypt(ym_region, ym_region_size, 8);
//}

//from pcm2.cpp--------------------------------------------------------------------------------

///*************************************************
// mslug5
//**************************************************/
//
//void neogeo_pvc_mslug5_cart_device::decrypt_all(DECRYPT_ALL_PARAMS)
//{
//	m_pvc_prot->mslug5_decrypt_68k(cpuregion, cpuregion_size);
//	m_pcm2_prot->swap(ym_region, ym_region_size, 2);
//	m_cmc_prot->cmc50_m1_decrypt(audiocrypt_region, audiocrypt_region_size, audiocpu_region, audio_region_size);
//	m_cmc_prot->cmc50_gfx_decrypt(spr_region, spr_region_size, MSLUG5_GFX_KEY);
//	m_cmc_prot->sfix_decrypt(spr_region, spr_region_size, fix_region, fix_region_size);
//}

